package com.tzld.piaoquan.content.understanding.service;

import com.tzld.piaoquan.content.understanding.model.param.*;
import com.tzld.piaoquan.content.understanding.model.vo.TaskResultVO;

/**
 * @author supeng
 */
public interface ContentService {

    /**
     * 内容分析处理
     *
     * @param param
     */
    void analyse(ContentAnalyseParam param);

    /**
     * 提交任务
     *
     * @param param
     * @return
     */
    TaskResultVO submitTasks(SubmitTasksParam param);

    /**
     * 查询任务
     *
     * @param param
     * @return
     */
    TaskResultVO queryTasks(QueryTasksParam param);

    /**
     * 新推荐
     */
    void newRecommendVideoUnderstandingHandler();

    /**
     * 当日头部
     */
    void dayTopVideoUnderstandingHandler();

    /**
     * 历史视频
     */
    void historyVideoUnderstandingHandler();

    /**
     * 剩余视频处理
     */
    void remainVideoUnderstandingHandler();

    /**
     * 剩余视频处理
     * @param videoId
     * @return
     */
    boolean remainVideoUnderstandingHandler(Long videoId);

    /**
     * 获取视频URL
     * <p>
     * 有多码率文件使用多码率文件（多码率文件目前不会被冻结/冷归档/深度冷归档和删除）
     * 没有多码率文件使用转码文件，转码文件被冻结/冷归档/深度冷归档，则需要解冻
     * 没有转码文件使用原文件，原文件被冻结/冷归档/深度冷归档，则需要解冻
     * 没有原文件则失败
     *
     * @param videoId 视频ID
     * @return 视频URL，如果视频不存在或正在解冻则返回null
     */
    String getVideoUrl(Long videoId);
}
